#include "gui.h"
#include <SDL/SDL_keysym.h>
#include "keyboard.h"

// TODO: Trap these? Map to SDL?
char ramDummyBlock[128*1024];


int bridgeRawRowPix() {
  return 0;
}


long g_LastKey;


struct {
  int isDown;
  int wasClicked;
  int wasReleased;
} KeyState[256];

void gKeyboard(int key, int state) {
  switch(key) {
    case SDLK_UP:
      g_LastKey = KEY_UP;
      break;
    case SDLK_DOWN:
      g_LastKey = KEY_DOWN;
      break;
    case SDLK_LEFT:
      g_LastKey = KEY_LEFT;
      break;
    case SDLK_RIGHT:
      g_LastKey = KEY_RIGHT;
      break;
    case SDLK_RETURN:
    //case SDLK_SPACE:	//???
      g_LastKey = KEY_SET;
      break;
    case SDLK_ESCAPE:
      g_LastKey = KEY_MENU;
      break;
    case SDLK_d:
      g_LastKey = KEY_DISPLAY;
      break;
    case SDLK_m:
      g_LastKey = KEY_MENU;
      break;
      
    default:
      return;
  }
 
 
  KeyState[g_LastKey].wasClicked = KeyState[g_LastKey].wasReleased = 0;
  
  if (state && !KeyState[g_LastKey].isDown) {
    KeyState[g_LastKey].wasClicked = 1;
  }
  if (!state && KeyState[g_LastKey].isDown) {
    KeyState[g_LastKey].wasReleased = 1;
  }
  
  KeyState[g_LastKey].isDown = state;
  
  if (!state) {
    g_LastKey = 0;
  }
  /*
  if (g_pHandler->kbd_process() == 0) {
    // normal button handling
  } else { // assume 1
    // force buttons pressed to be blocked from Camera firmware
  }
  */
  
 // g_LastKey = 0;
}


//
// Platform-specific stubs
//
// THIS SHOULD MIMIC CAMERA


long lens_get_zoom_pos()
{
    return 0;
}

void lens_set_zoom_pos(long newpos)
{
}

long lens_get_zoom_point()
{
    return 0;
}

void lens_set_zoom_point(long newpt)
{}
void vid_bitmap_refresh() {
}


// debug.c
void dbg_start() {}
void dbg_stop() {}
void dbg_log(char *str) {}
void go_debug(long kbd_state[]) {}

// kbd.c
///*
long wrap_kbd_p1_f(){}
void my_kbd_read_keys(){}
void kbd_key_press(long key){
  //KeyState[g_LastKey].wasClicked = 1;
  key = 4;
}
void kbd_key_release(long key){
  key = 5;
}
void kbd_key_release_all(){
  int i=0;
  for(;i<256;++i) {
    KeyState[g_LastKey].isDown = KeyState[g_LastKey].wasClicked = KeyState[g_LastKey].wasReleased = 0;
  }
}

long kbd_is_key_pressed(long key){
  return KeyState[key].isDown;
}
long kbd_is_key_clicked(long key){
  return KeyState[key].wasClicked;
}
long kbd_get_pressed_key(){
  return g_LastKey;
}
long kbd_get_clicked_key(){
  return g_LastKey;
}
long kbd_use_zoom_as_mf(){}
void kbd_fetch_data(long *dst){}
//*/

// lib.c
int get_flash_params_count(void){
 return 111;
}

//void shutdown(){ while(1);}
void debug_led(int state){}
void camera_set_led(int led, int state, int bright){}

// main.c
long get_vbatt_min()
{
	return 2100;
}

long get_vbatt_max(){return 2800;}


int get_effective_focal_length(int zp)
{
	return (60345*get_focal_length(zp))/10000;
}

int get_focal_length(int zp) { return 0; }

int get_zoom_x(int zp) { return 0; }

// shooting.c

long get_file_next_counter() { return 0; }
long get_target_file_num() { return 0; }
long get_target_dir_num() { return 0; }

// wrappers.c

long lens_get_focus_pos() { return 0; }
long lens_get_focus_pos_from_lens() { return 0; }
long lens_get_target_distance() { return 0; }

// sub/boot.c
void boot(){}

// sub/lib.c

void *hook_raw_fptr()
{
    return (void*)0x42990;	//sync with a630
}

void *hook_raw_ret_addr()
{
    return (void*)0x0;
}

char *hook_raw_image_addr()
{
    return (char*)0x10563530;	//sync with a630
}

long hook_raw_size()	//sync with a560 (on wiki page)
{
    return 0x8CAE10;
}

void *vid_get_viewport_live_fb() // 0x105F0000 + 0xF20 + 0x7E000 + 0x900 (find on "VRAM Address  : %p")
{
    return (void*)ramDummyBlock;
}

void *vid_get_bitmap_fb()
{
    return (void*)ramDummyBlock; //(0x10360000 + 0x1000)	//sync with ixus70 (on forum)
}

void *vid_get_viewport_fb()
{
	return (void*)ramDummyBlock; //sync with a610	
}

void *vid_get_viewport_fb_d()
{
    return (void*)(*(int*)ramDummyBlock); //sync with a540 and ixus70 (on forum)
}

long vid_get_viewport_height()
{
    return 240;		//((mode_get()&MODE_MASK) == MODE_PLAY)?240:230;
}

void _EnterToCompensationEVF(void) {} // Dummy function. To be removed after stub is found. See stubs_entry_2.S.
void _ExitFromCompensationEVF(void) {} // Dummy function. To be removed after stub is found. See stubs_entry_2.S.





long xxxxxxkbd_get_autoclicked_key() {
  return g_LastKey;
  /*
          case KEY_UP:
              moveCursor(gState.cursor_x, gState.cursor_y-gState.cursor_h);
              break;
          case KEY_DOWN:
              moveCursor(gState.cursor_x, gState.cursor_y+gState.cursor_h);
              break;
          case KEY_LEFT:
              moveCursor(gState.cursor_x-gState.cursor_w, gState.cursor_y);
              break;
          case KEY_RIGHT:
              moveCursor(gState.cursor_x+gState.cursor_w, gState.cursor_y);
              break;
          case KEY_SET:() {
  return 0;
  */
}


// Others



const unsigned int param_file_counter;


// Data tables (shooting.c)
#include "platform.h"


void drv_self_hide(void){}
void drv_self_unhide(void){}
void hook_raw_save_complete(){}
char *hook_alt_raw_image_addr() { return 0; }

int circle_of_confusion = 5;

#define NUM_FL      8   // 0 - 7, entries in firmware
const int zoom_points = NUM_FL;


const ApertureSize aperture_sizes_table[] = {

    {  8, 273, "2.6" },
    {  9, 288, "2.8" },
    { 10, 320, "3.2" },
    { 11, 352, "3.5" },
    { 12, 384, "4.0" },
    { 13, 416, "4.5" },
    { 14, 448, "5.0" },
    { 15, 480, "5.6" },
    { 16, 512, "6.3" },
    { 17, 544, "7.1" },
    { 18, 576, "8.0" },
};

const ShutterSpeed shutter_speeds_table[] = {
    { -12, -384, "15", 15000000 },
    { -11, -352, "13", 13000000 },
    { -10, -320, "10", 10000000 },
    {  -9, -288, "8",   8000000 },
    {  -8, -256, "6",   6000000 },
    {  -7, -224, "5",   5000000 },
    {  -6, -192, "4",   4000000 },
    {  -5, -160, "3.2", 3200000 },
    {  -4, -128, "2.5", 2500000 },
    {  -3,  -96, "2",   2000000 },
    {  -2,  -64, "1.6", 1600000 },
    {  -1,  -32, "1.3", 1300000 },
    {   0,    0, "1",   1000000 },
    {   1,   32, "0.8",  800000 },
    {   2,   64, "0.6",  600000 },
    {   3,   96, "0.5",  500000 },
    {   4,  128, "0.4",  400000 },
    {   5,  160, "0.3",  300000 },
    {   6,  192, "1/4",  250000 },
    {   7,  224, "1/5",  200000 },
    {   8,  256, "1/6",  166667 },
    {   9,  288, "1/8",  125000 },
    {  10,  320, "1/10", 100000 },
    {  11,  352, "1/13",  76923 },
    {  12,  384, "1/15",  66667 },
    {  13,  416, "1/20",  50000 },
    {  14,  448, "1/25",  40000 },
    {  15,  480, "1/30",  33333 },
    {  16,  512, "1/40",  25000 },
    {  17,  544, "1/50",  20000 },
    {  18,  576, "1/60",  16667 },
    {  19,  608, "1/80",  12500 },
    {  20,  640, "1/100", 10000 },
    {  21,  672, "1/125",  8000 },
    {  22,  704, "1/160",  6250 },
    {  23,  736, "1/200",  5000 },
    {  24,  768, "1/250",  4000 },
    {  25,  800, "1/320",  3125 },
    {  26,  832, "1/400",  2500 },
    {  27,  864, "1/500",  2000 },
    {  28,  896, "1/640",  1563 },
    {  29,  928, "1/800",  1250 },
    {  30,  960, "1/1000", 1000 },
    {  31,  992, "1/1250",  800 },
    {  32, 1021, "1/1600",  625 },
    {  33, 1053, "1/2000",  500 },
};

const ISOTable iso_table[] = {
    { -1,    1,   "HI", -1},
    {  0,    0, "Auto", -1},
    {  1,   80,   "80", -1},
    {  2,  100,  "100", -1},
    {  3,  200,  "200", -1},
    {  4,  400,  "400", -1},
    {  5,  800,  "800", -1},
    {  6, 1600, "1600", -1},
};          

/*
http://www.usa.canon.com/consumer/controller?act=ModelInfoAct&fcategoryid=221&modelid=14824#ModelTechSpecsAct
Shooting Modes
    Auto, Camera M, Portrait, Landscape,
    Special Scene
        (Night Scene, Foliage, Snow, Beach, Fireworks)
    Indoor, Kids & Pets, Night Snapshot, Movie
Movie: 640 x 480 / 320 x 240 (30 fps/15 fps)available up to 1GB or 1 hour for each file size,
    320 x 240 (1 min. at 60 fps), 160 x 120 (3 min. at 15 fps) 
canon mode list FFEA9F04 in 100c
*/
const CapturemodeMap modemap[] = {
    { MODE_LONG_SHUTTER,        32774 }, // guessed
    { MODE_AUTO,                32768 },
    { MODE_P,                   32772 },
    { MODE_VIDEO_STD,           2597  },
    { MODE_VIDEO_SPEED,         2598  },
    { MODE_VIDEO_COMPACT,       2599  },
//    { MODE_SCN_AQUARIUM,        16407 }, not in canon list
    { MODE_SCN_NIGHT_SCENE,     16398 },
    { MODE_SCN_FOLIAGE,         16402 },
    { MODE_SCN_SNOW,            16403 },
    { MODE_SCN_BEACH,           16404 },
    { MODE_SCN_FIREWORK,        16405 },
    { MODE_INDOOR,              32785 },
    { MODE_KIDS_PETS,           32784 },
    { MODE_NIGHT_SNAPSHOT,      32779 },
    { MODE_LANDSCAPE,           32780 },
    { MODE_PORTRAIT,            32781 }, 
};

// Assembler
volatile long focus_busy;

#include "system/platform/generic/shooting.c"
#include <gui_osd.h>

// Video
void change_video_tables(int a, int b){}
void movie_record_task(){}


int movie_status;
int zoom_status;
const int zoom_points;
int circle_of_confusion;
int recreview_hold;

long playrec_mode;
// USB
void usb_remote_active(){}

// Stdlib - custom
// From generic wrappers.c - DRYOS
#define _U      0x01    /* upper */ 
#define _L      0x02    /* lower */ 
#define _D      0x04    /* digit */ 
#define _C      0x20    /* cntrl */ 
#define _P      0x10    /* punct */ 
#define _S      0x40    /* white space (space/lf/tab) */ 
#define _X      0x80    /* hex digit */ 
#define _SP     0x08    /* hard space (0x20) */ 
/*
static int _ctype(int c,int t) {
    extern unsigned char ctypes[];  // Firmware ctypes table (in stubs_entry.S) 
    return ctypes[c&0xFF] & t;
}
int _isdigit(int c) { return _ctype(c,_D); }
int _isspace(int c) { return _ctype(c,_S); }
int _isalpha(int c) { return _ctype(c,(_U|_L)); }
int _isupper(int c) { return _ctype(c,_U); }
int _islower(int c) { return _ctype(c,_L); }
int _ispunct(int c) { return _ctype(c,_P); }
int _isxdigit(int c) { return _ctype(c,(_X|_D)); }
int _iscntrl(int c) { return _ctype(c,_C); }

int _tolower(int c) { return isupper(c) ? c | 0x20 : c; }
int _toupper(int c) { return islower(c) ? c & ~0x20 : c; }

*/
// Use these instead of the ones in wrappes.c
long mkdir_if_not_exist(const char *dirname) {
  mkdir(dirname);
  return 0;
}


void msleep(long msec)
{
    SDL_Delay(msec);
}

long task_lock()
{
    return 0;
}

long task_unlock()
{
    return 0;
}

const char *_taskName(int id)
{
    return "";
}

int task_id_list_get(int *idlist,int size)
{
    return 0;
}

long get_property_case(long id, void *buf, long bufsize)
{
    return 0;
}

long set_property_case(long id, void *buf, long bufsize)
{
    return 0;
}

void _UpdateMBROnFlash(int driveno, long offset, char *str)
{

}

void  _RefreshPhysicalScreen(long f)
{

}

short get_parameter_size(long id){return 1;}

long get_parameter_data(long id, void *buf, long bufsize)
{
    return 0;
}

long set_parameter_data(long id, void *buf, long bufsize)
{
    return 0;
}
//

void lens_set_zoom_speed(long newspd)
{
 }

void lens_set_focus_pos(long newpos)
{
}

void play_sound(unsigned sound){}


long stat_get_vbatt()
{
    return 100;
}

int get_battery_temp()
{
    return 0;
}

int get_ccd_temp()
{
    return 0;
}

int get_optical_temp()
{
    return 0;
}

long get_tick_count()
{
  return SDL_GetTicks();
  /*
long t;
#if !CAM_DRYOS
    _GetSystemTime(&t);
    return t;
#else
    return (int)_GetSystemTime(&t);
#endif
*/
}

#if CAM_HAS_ND_FILTER
void PutInNdFilter()                {  }
void PutOutNdFilter()               {  }
#endif

long GetCurrentAvValue()            { return 0; }
long IsStrobeChargeCompleted()      { return 1; }
void SetCurrentCaptureModeType()    {  }

#if CAM_CAN_UNLOCK_OPTICAL_ZOOM_IN_VIDEO
void UnsetZoomForMovie()            {  }
#endif

#ifdef CAM_AV_OVERRIDE_IRIS_FIX
int MoveIrisWithAv(short *v)        { return 0; }
#endif

#if CAM_EV_IN_VIDEO
void ExpCtrlTool_StartContiAE(int v1, int v2)   {  }
void ExpCtrlTool_StopContiAE(int v1, int v2)    {  }
short SetAE_ShutterSpeed(short *tv)             { }
#endif



long _MoveZoomLensWithPoint(short*p) {
  return 0;
}
volatile long zoom_busy = 0;

typedef struct
{
    short   unk1;
    short   unk2;
    void*   data;   // Pointer to param data
    short   size;   // param size
    short   unk3;
    int     unk4;
    short   unk5;
    short   unk6;
} flashParam;
flashParam* FlashParamsTable[16];

// levent

void SetLogicalEventActive(unsigned event, unsigned state){};
void PostLogicalEventForNotPowerType(unsigned event, unsigned unk){}
void PostLogicalEventToUI(unsigned event, unsigned unk){}
void SetScriptMode(unsigned mode){}

int switch_mode_usb(int mode){ return 0;}// 0 = playback, 1 = record; return indicates success
                                      // N.B.: switch_mode only supported when USB is connected


int get_usb_bit_physw(void)
{
    return 0;
}




// VIEWPORT
// we can about this be

int __attribute__((weak)) vid_get_viewport_width() {
	return camera_screen.width;
}

// Physical width of viewport row in bytes
int __attribute__((weak)) vid_get_viewport_byte_width() {
	return 720 * 6 / 4;     // For most cameras viewport is 720 pixels wide, each group of 4 pixels uses 6 bytes (UYVYYY)
}

// Y multiplier for cameras with 480 pixel high viewports (CHDK code assumes 240)
int __attribute__((weak)) vid_get_viewport_yscale() {
	return 1;               // For most cameras viewport is 240 pixels high
}

// viewport x offset - used when image size != viewport size (zebra, histogram, motion detect & edge overlay)
int __attribute__((weak)) vid_get_viewport_xoffset() {
	return 0;
}

// viewport y offset - used when image size != viewport size (zebra, histogram, motion detect & edge overlay)
int __attribute__((weak)) vid_get_viewport_yoffset() {
	return 0;
}

// viewport display x offset - used when image size != viewport size (zebra, histogram, motion detect & edge overlay)
int __attribute__((weak)) vid_get_viewport_display_xoffset() {
	return vid_get_viewport_xoffset();
}

// viewport display y offset - used when image size != viewport size (zebra, histogram, motion detect & edge overlay)
int __attribute__((weak)) vid_get_viewport_display_yoffset() {
	return vid_get_viewport_yoffset();
}

// viewport image offset - used when image size != viewport size (zebra, histogram, motion detect & edge overlay)
// returns the byte offset into the viewport buffer where the image pixels start (to skip any black borders)
// see G12 port for sample implementation
int vid_get_viewport_image_offset() {
	return (vid_get_viewport_yoffset() * vid_get_viewport_byte_width() * vid_get_viewport_yscale()) + (vid_get_viewport_xoffset() * 3);
}

// viewport image offset - used when image size != viewport size (zebra, histogram, motion detect & edge overlay)
// returns the byte offset to skip at the end of a viewport buffer row to get to the next row.
// see G12 port for sample implementation
int vid_get_viewport_row_offset() {
	return (vid_get_viewport_byte_width() * vid_get_viewport_yscale()) - (vid_get_viewport_width() * 3);
}



void __attribute__((weak)) *vid_get_bitmap_active_buffer()
{
  return vid_get_bitmap_fb();   // *** does not get the active buffer! (override if active buffer can be determined)
}

void __attribute__((weak)) *vid_get_bitmap_active_palette()
{
  return 0; // return no palette info unless overridden
}

// Get active viewport buffer address based on PLAY/REC mode.
// Try to use 'live' buffer in REC mode if vid_get_viewport_live_fb is implemented
// can return NULL in plaback mode, if a video is selected
void *vid_get_viewport_active_buffer()
{
  void *p;

  if ( (mode_get()&MODE_MASK) == MODE_PLAY )
  {
    p = vid_get_viewport_fb_d();
  } else {
    p = vid_get_viewport_live_fb();
    if ( !p )
    {
      p = vid_get_viewport_fb();
    }
  }
  
  return p;
}

// camera_info.c
 long link_text_start;
 long link_data_start;
 long link_bss_start;
 long link_bss_end;

void change_ext_to_dng(void) {}
void change_ext_to_default() {}
void save_ext_for_dng(void){}
void disable_shutdown(void){}
void enable_shutdown(void){}

void *umalloc(long size){ return malloc(size); }
void ufree(void *p) { free(p); }


// SDCARD

 unsigned int GetFreeCardSpaceKb(void){ return 0; }
 unsigned int GetTotalCardSpaceKb(void){ return 0; }

 unsigned int GetJpgCount(void){ return 0L; }
 unsigned int GetRawCount(void){ return 0L; }

 char * camera_jpeg_count_str(){ return (char *)0xF840; }

 int swap_partitions(int new_partition){ return 0; }
 unsigned char get_active_partition(void){ return 0; }
 int get_part_type(void){ return 0; }
 int get_part_count(void){ return 0; }
 int is_partition_changed(void){ return 0; }
 void create_partitions(void){}

 void mark_filesystem_bootable(){}


 // core/usb_remote.
 
int get_usb_power(int p){return 0;}
void clear_usb_power(){}


//main.bin.dump
void vid_turn_on_updates(){}
void vid_turn_off_updates(){}
long get_jogdial_direction(void){return 0;}


struct tm * get_localtime() { 
  time_t local;
  struct tm *p = localtime(&local);
  return p;  
}
#if 0
	int tm_sec;	/* seconds after the minute	- [0, 59] */
	int tm_min;	/* minutes after the hour	- [0, 59] */
	int tm_hour;	/* hours after midnight		- [0, 23] */
	int tm_mday;	/* day of the month		- [1, 31] */
	int tm_mon;	/* months since January		- [0, 11] */
	int tm_year;	/* years since 1900	*/
	int tm_wday;	/* days since Sunday		- [0, 6] */
	int tm_yday;	/* days since January 1		- [0, 365] */
	int tm_isdst;	/* Daylight Saving Time flag */
	};

 typedef unsigned long time_t;

extern struct tm * localtime(const time_t *_tod);
#endif

int canon_menu_active = 0;
char canon_shoot_menu_active = 0;
void EnterToCompensationEVF(){}
void MakeAFScan(){}
int handle_usb_remote() { return 0; }


void GetMemInfo(cam_meminfo*p) {
}

int GetExMemInfo(cam_meminfo*p) {
  return 0;
}

/*int core_get_free_memory() {
  return 64*1024;
}
*/




#include "levent.h"

levent_def levent_table[64];





// PTP Live View functions
// These functions return actual size/offset in pixels of the viewport and bitmap buffers
 int vid_get_viewport_display_xoffset_proper()   // X Offset (for variable image size)
 {
   return 0;
 }
 
 int vid_get_viewport_display_yoffset_proper()   // Y Offset (for variable image size)
{
   return 0;
 }
 
  int vid_get_viewport_width_proper()            // Visible viewport width (for variable image size)
 {
   return 0;
 }
 
 int vid_get_viewport_height_proper()           // Visible viewport height (for variable image size)
 {
   return 0;
 }
 
 int vid_get_viewport_fullscreen_width()            // Width of screen in buffer pixels
 {
   return 0;
 }
 
 int vid_get_viewport_fullscreen_height()           // Height of screen in buffer pixels
 {
   return 0;
 }
 
 int vid_get_viewport_buffer_width_proper()      // Physical viewport buffer width in pixels
 {
   return 0;
 }
 
 int vid_get_palette_type()                      // Palette type (0 - 3)
 {
   return 0;
 }
 
 int vid_get_palette_size()                      // Palette size (in bytes)
{
   return 0;
 }
 
  int vid_get_aspect_ratio()                    // LCD aspect ratio (0 = 4:3 or 1 = 16:9)
{
   return 0;
 }
 
 
// PTP chdk
#include "ptp_chdk.h"

int add_ptp_handler(int opcode, ptp_handler handler, int unknown) {
  return 0;
  
}


 // callfunc.c
 unsigned call_func_ptr(void *func, const unsigned *args, unsigned n_args) {
   return 0;
 }
 
 
 // task.h
int CreateTask (const char *name, int prio, int stack_size, void *entry) {
  return 0;
}

void ExitTask(){}


// TODO:
int usb_sync_wait;


// CACHE
void icache_flush_all(void){}
void dcache_clean_all(void){}



// ubasic??? camera_functions???
void TurnOnBackLight(){}
void TurnOffBackLight(){}
void DoAFLock(){}
void UnlockAF(){}
void TurnOnDisplay(void){}
void TurnOffDisplay(void){}
void JogDial_CW(void){}
void JogDial_CCW(void){}

unsigned char SetFileAttributes(const char* fn, unsigned char attr) {
  return 0;
}
int errnoOfTaskGet(int tid) { return 0; }
void camera_shutdown_in_a_second(void){}
unsigned _ExecuteEventProcedure(const char *name, ...) {
  return 0;  
}


