#include "SDL/SDL_types.h"
#include "dagger.h"



Dagger *
daggerInit(const char *pDeviceName) {
  Dagger *p = malloc(sizeof(Dagger));

  // It defaults to an A550, 7 MP, camera.
  // For others we need to create a factory, and move all the platform
  // specific #define's into run-time code.
  p->pDeviceName = pDeviceName;
  p->screenWidth = 360;
  p->screenHeight = 240;
  
  p->rawWidth = 3152;
  p->rawHeight = 2340;

  mkdir_if_not_exist("A");
  gui_init();
  conf_restore();
  conf_load_defaults();
  
  return p;
}

Uint32
daggerGetWidth(Dagger *p) {
  return p->screenWidth;
}

Uint32
daggerGetHeight(Dagger *p) {
  return p->screenHeight;
}

void
daggerReset(Dagger *p, cbInitializer initRoutine) {
  sdlWrapperPreRender();
    initRoutine();
    gui_redraw(); 
  sdlWrapperPostRender();
}

void
daggerUpdate(Dagger *p) {
  sdlWrapperPreRender();
    gui_redraw();
    kbd_process();
    gui_kbd_process();
  sdlWrapperPostRender();
}

void
daggerExit(Dagger *p) {
  free((void *)p);
}
