#ifndef DAGGER_H
#define DAGGER_H

// Dagger is the virtual camera device. Both settings & methods.

typedef struct  {
  // Setup
  const char *	pDeviceName;
  Uint32	screenWidth, screenHeight;  
  Uint32	rawWidth, rawHeight;  
  //
  void		(*pUpdate)(float telaps);
  
  // State
  // n/a
  
} Dagger;

typedef int 	(*cbInitializer)(void);

Dagger *	daggerInit(const char *pDeviceName);
void		daggerReset(Dagger *p, cbInitializer initRoutine);

Uint32		daggerGetWidth(Dagger *p);
Uint32		daggerGetHeight(Dagger *p);

void 		daggerUpdate(Dagger *p);
void 		daggerExit(Dagger *p);

#endif	//DAGGER_H
